using Blazorise;
using FoodsharingSiegen.Contracts.Entity;
using FoodsharingSiegen.Contracts.Model;
using FoodsharingSiegen.Server.Data.Service;
using FoodsharingSiegen.Server.Dialogs;
using Microsoft.AspNetCore.Components;

namespace FoodsharingSiegen.Server.Pages
{
    /// <summary>
    /// The prospects class (a. beging, 11.04.2022)
    /// </summary>
    public partial class Prospects
    {
        #region Dependencies (Injected)

        /// <summary>
        /// Gets or sets the value of the prospect service (ab)
        /// </summary>
        [Inject] public ProspectService ProspectService { get; set; } = null!;

        /// <summary>
        /// Gets or sets the value of the user service (ab)
        /// </summary>
        [Inject] public UserService UserService { get; set; } = null!;

        #endregion

        #region Public Properties

        /// <summary>
        /// Gets or sets the value of the interaction modal (ab)
        /// </summary>
        private AddInteractionModal? InteractionModal { get; set; }

        /// <summary>
        /// Gets or sets the value of the prospect list (ab)
        /// </summary>
        private List<Prospect>? ProspectList { get; set; }

        /// <summary>
        /// Gets or sets the value of the prospect modal (ab)
        /// </summary>
        private AddProspectModal ProspectModal { get; set; } = null!;

        /// <summary>
        /// Gets or sets the value of the users (ab)
        /// </summary>
        private List<User>? Users { get; set; }

        #endregion

        #region Override OnAfterRenderAsync

        /// <summary>
        /// Ons the after render using the specified first render (a. beging, 11.04.2022)
        /// </summary>
        /// <param name="firstRender">The first render</param>
        protected override async Task OnAfterRenderAsync(bool firstRender)
        {
            if (firstRender)
                await LoadProspects();

            await base.OnAfterRenderAsync(firstRender);
        }

        #endregion

        #region Override OnInitializedAsync

        /// <summary>
        /// Ons the initialized (a. beging, 11.04.2022)
        /// </summary>
        protected override async Task OnInitializedAsync()
        {
            var getUsersR = await UserService.GetUsersAsync();
            if (getUsersR.Success)
                Users = getUsersR.Data;
            
            await base.OnInitializedAsync();
        }

        #endregion

        #region Private Method LoadProspects

        /// <summary>
        /// Loads the prospects (a. beging, 11.04.2022)
        /// </summary>
        private async Task LoadProspects()
        {
            var parameter = new GetProspectsParameter
            {
                CannotHaveInteractions = new List<InteractionType> { InteractionType.Complete, InteractionType.Verify }
            };
            var prospectsR = await ProspectService.GetProspectsAsync(parameter);
            if (prospectsR.Success) ProspectList = prospectsR.Data;
            
            await InvokeAsync(StateHasChanged);
        }

        #endregion

        #region Private Method OnAddInteraction

        /// <summary>
        /// Ons the add interaction using the specified arg (a. beging, 11.04.2022)
        /// </summary>
        /// <param name="arg">The arg</param>
        private async Task OnAddInteraction(Interaction arg)
        {
            await ProspectService.AddInteraction(arg);
            await LoadProspects();
        }

        #endregion

        #region Private Method OnAddProspect

        /// <summary>
        /// Ons the add prospect using the specified arg (a. beging, 11.04.2022)
        /// </summary>
        /// <param name="arg">The arg</param>
        private async Task OnAddProspect(Prospect arg)
        {
            var addProspectR = await ProspectService.AddProspectAsync(arg);
            if (addProspectR.Success) await LoadProspects();
        }

        #endregion

        #region Private Method OnUpdateProspect

        /// <summary>
        /// Ons the update prospect using the specified prospect (a. beging, 11.04.2022)
        /// </summary>
        /// <param name="prospect">The prospect</param>
        private async Task OnUpdateProspect(Prospect prospect)
        {
            var updateProspectR = await ProspectService.UpdateAsync(prospect);
            if (updateProspectR.Success) await LoadProspects();
        }

        #endregion

        #region Private Method RemoveInteraction

        /// <summary>
        /// Removes the interaction using the specified arg (a. beging, 11.04.2022)
        /// </summary>
        /// <param name="arg">The arg</param>
        private async Task RemoveInteraction(Guid arg)
        {
            var confirm = await Message.Confirm("Interaktion wirklich löschen?", "Bestätigen", o => { 
                o.ConfirmButtonText = "Ja, wirklich!";
                o.CancelButtonText = "Abbrechen";
                o.ShowMessageIcon = false;
            });

            if (confirm)
            {
                await ProspectService.RemoveInteraction(arg);
                await LoadProspects();
            }

            await InvokeAsync(StateHasChanged);
        }

        #endregion
    }
}